{ geg:
  Eine Gerade ist in Parameterdarstellung gegeben.   (1)   P = O1 + t*U
  Ein Kreis in allgemeiner Lage                      (2)   (P-M)^2 = R^2
  ges:
  Schnittpunkte?
  Zuerst muss der Richtungsvektor U normiert werden !!!!
  Wir setzen die erste Gleichung in die zweite Gleichung ein.:
  (O + t*U - M)^2 = R^2
  Wir bilden die Vektordifferenz von (O - M) und nennen sie MO:
  (MO + t*U)^2 = R^2
  Wir quadrieren nach der Formel (a+b)^2 = a^2 + 2ab + b^2:
  (MO)^2 + 2*t*(MO*U) + t^2*U^2 = R^2
  Weil U ein Einheitsvektor ist, ist U^2 ein Skalar und gleichzeitig 1.
  (MO)^2 + 2*t*(MO*U) + t^2 = R^2
  Wir ordnen nach der Formel fuer eine quadratische Gleichung:
      t^2 + 2*t*(MO*U) + (MO)^2-R^2 = 0
   A* X^2 +  B*X       +     C      = 0
   Koeffizienten:
   A = 1,          B = 2*(MO*U),       C =(MO)^2-R^2.
   Zwischenergebnisse:
   (MO*U) nennen wir MOU       (MO)^2 nennen wir MO2                 }




PROGRAM lincirc;                        (* Schnitt Gerade Kreis 2.2.1997 *)
USES CRT,UNIGRA12;

CONST
Eps = 1.0E-12;

TYPE
Line2D = RECORD                                                     
             O: Pt2D;
             U: Vt2D;
           END;

Circle = RECORD                                                      
             M: Pt2D;
             R: EXTENDED;
           END;

VAR
Kreis       : Circle;                    (* Kreis                         *) 
Line        : Line2D;                    (* Linie                         *)
t1,t2       : EXTENDED;                  (* Parameter der Geraden =       *)
                                         (* Loesungen der quadr. Gleich.  *)
S1,S2       : Pt2D;                      (* Schnittpunkte                 *)
NoS         : INTEGER;                   (* number of solutions = Anzahl  *)
                                         (* der Loesungen 1, 2 oder 0 =   *)
                                         (* kein Schnittpunkt             *)
 
{ ------------------------- Unterprogramme ------------------------------ }
Procedure Ausgangszustand_definieren;
   BEGIN
   Plotter_einschalten;
   Graphik_einschalten('D:\TP6\TPUS');
   Weltgrenzen_festlegen(einh);  
   Viewport_festlegen;
   GeraetefensterPlotter_festlegen;
   Parameter2D;
   Portrait  := FALSE;                   (* Querformat Bild liegend        *)
   Plast.X := WI2D[1].X;                 (* letzter Punkt initialisieren   *)
   Plast.Y := WI2D[1].Y;
   Viewport_zeichnen; 
   Koordinatenachsen_zeichnen;
   Gitter(0.3,2.0,10.0);(* Strich,              klE,             grE     *)
                       (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
  END;

Procedure Beschriftung;
  VAR
  T: Ttyp;
  XUntergr,XObergr,YUntergr,YObergr,einhS,SXS,SYS: STRING[Bz1];
  LineOXS,LineOYS,LineUXS,LineUYS                : STRING[Bz1];
  MXS,MYS,RadiusS,S1XS,S1YS,S2XS,S2YS,NoSS       : STRING[Bz1];
  Ttemp1,Ttemp2: STRING[Bz2];

  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(einh:5:3,einhS);
  
  STR(Line.O.X:5:2,LineOXS);  STR(Line.O.Y:5:2,LineOYS);
  STR(Line.U.X:5:2,LineUXS);  STR(Line.U.Y:5:2,LineUYS);
  STR(Kreis.M.X:5:2,MXS);  STR(Kreis.M.Y:5:2,MYS);
  STR(Kreis.R:5:2,RadiusS);
  STR(S1.X:5:2,S1XS);   STR(S1.Y:5:2,S1YS);
  STR(S2.X:5:2,S2XS);   STR(S2.Y:5:2,S2YS);
  STR(NoS:5,NoSS);
(* ----------------------------- TEXTE --------------------------------- *)
  T[1] := 'Schnitt Kreis/Gerade:';
  Ttemp1 := 'Gerade; Punkt('+LineOXS+'/'+LineOYS+')';
  Ttemp2 := ' Richtungsvektor('+LineUXS+'/'+LineUYS+')';
  T[2] := Ttemp1 + Ttemp2;
  Ttemp1 := 'Kreis: Punkt('+MXS+'/'+MYS+')';
  Ttemp2 := ' Radius('+RadiusS+')';
  T[3] := Ttemp1 + Ttemp2;
        Ttemp1 := 'Weltgrenzen: X von '+XUntergr+' bis '+XObergr;
        Ttemp2 := '   Y von '+YUntergr+' bis '+YObergr;
  T[4] := Ttemp1 + Ttemp2;
  T[5] := '1 Einheit entspricht '+einhS+'  cm';
  CASE NoS  OF
    0: BEGIN T[6] := 'Gerade schneidet den Kreis nicht'; END;
    1: BEGIN Ttemp1 := 'Die Gerade ist eine Tangente Beruehrungspunkt: (';
             Ttemp2 := S1XS + '/' + S1YS + ')';
             T[6]   := Ttemp1+Ttemp2;
       END;
    2: BEGIN Ttemp1 := '2 Schnittpunkte:  Punkt1:('+ S1XS + '/' + S1YS + ')';
             Ttemp2 := '    Punkt2:('+ S2XS + '/' + S2YS + ')';
             T[6]   := Ttemp1+Ttemp2;
       END;
  END;
  Text_ausgeben(T,6);                                 (* 2 Texte ausgeben *)
  END;

PROCEDURE SquareEquation(A,B,C: EXTENDED; VAR NOS: INTEGER;
                         VAR T1,T2: EXTENDED);
CONST
Eps1 = 1.0E-6;             (* muss groesser als allgemeinenes Epsilon sein *)

VAR
D,TC: EXTENDED;
BEGIN
  CASE Null(A,Eps1) OF
    TRUE: BEGIN
      IF Null(B,Eps1) THEN NOS:=0
      ELSE BEGIN NOS:=1; T1:=-C/B; T2:=T1; END;
    END;
    FALSE: BEGIN
      D:=B*B-4*A*C;
      IF Null(D,Eps1) THEN BEGIN
        NOS:=1 ;
        T1:=-B/2/A; T2:=T1;
      END
      ELSE BEGIN
        IF D>0 THEN BEGIN
          NOS:=2;
          T1:=(-B+SQRT(D))/2/A;
          T2:=(-B-SQRT(D))/2/A;
          IF T1>T2 THEN BEGIN
            TC:=T1; T1:=T2; T2:=TC;
          END;
        END
        ELSE NOS:=0;
      END;
    END;
  END;
END;

PROCEDURE LengthVt2D(V: Vt2D; VAR L: EXTENDED);
BEGIN
  L := SQRT(SQR(V.X)+SQR(V.Y)+Eps);
END;

PROCEDURE ScaleVt2D(V: Vt2D; LG: EXTENDED; VAR ScalV: Vt2D);
VAR L: EXTENDED;
BEGIN
  ScalV:=V;
  LengthVt2D(V, L);
  IF NOT Null(L,Eps) THEN BEGIN
    ScalV.X:=V.X/L*LG;
    ScalV.Y:=V.Y/L*LG;
  END;
END;

PROCEDURE DifferenceVt2D(V1,V2: Vt2D; VAR DV: Vt2D);
BEGIN
  DV.X:=V1.X-V2.X;
  DV.Y:=V1.Y-V2.Y;
END;

PROCEDURE LinearCombinationVt2D(S1,S2: EXTENDED; V1,V2: Vt2D; VAR LC: Vt2D);
BEGIN
  LC.X:=S1*V1.X+S2*V2.X;
  LC.Y:=S1*V1.Y+S2*V2.Y;
END;

PROCEDURE ScalarProductVt2D(V1,V2: Vt2D; VAR SP: EXTENDED);
BEGIN
  SP:=V1.X*V2.X+V1.Y*V2.Y;
END;

PROCEDURE TToLine2D(Ln2D: Line2D; T: EXTENDED; VAR P: Pt2D);
BEGIN
  LinearCombinationVt2D(1,T,Ln2D.O,Ln2D.U, P);
END;

PROCEDURE IntersectionLineCircle(Ln2D: Line2D; Kreis: Circle;
                                 VAR NOS: INTEGER; VAR T1,T2: EXTENDED;
                                 VAR S1,S2: Pt2D);
VAR MO2,MOU,A,B,C: EXTENDED;
    MO: Vt2D;
BEGIN
  DifferenceVt2D(Ln2D.O,Kreis.M, MO);
  ScalarProductVt2D(MO,MO, MO2);
  ScalarProductVt2D(MO,Ln2D.U, MOU);
  A := 1; B := 2*MOU; C := MO2-SQR(Kreis.R);
  SquareEquation(A,B,C, NOS,T1,T2);
  IF NOS>0 THEN BEGIN
    TToLine2D(Ln2D,T1, S1);
    TToLine2D(Ln2D,T2, S2);
  END;
END;

PROCEDURE TtoXY(Kreis: Circle; T: EXTENDED; VAR X,Y: EXTENDED);
    BEGIN
      X := Kreis.M.X+Kreis.R*COS(T);           (* Umrechnung in           *)
      Y := Kreis.M.Y+Kreis.R*SIN(T);           (* Kartesische Koordinaten *)
    END;

PROCEDURE Zeichne_Kreis(Kreis: Circle; TMin,TMax: EXTENDED; TSteps : INTEGER);
   VAR
     I: INTEGER;
     X,Y,T,DeltaT: EXTENDED;
     P: Pt2D;
   BEGIN
     DeltaT := (TMax-TMin)/TSteps;
     T := TMin;                                         
     TtoXY(Kreis,T,X,Y);
     P.X := X; P.Y := Y;
     MoveToPt2D(P);
     FOR I := 0 TO TSteps DO
       BEGIN
         T := TMin + I*DeltaT;
         TtoXY(Kreis,T,X,Y);
         P.X := X; P.Y := Y;
         DrawLine2D(PLast,P,Col);
       END;        
    END;

PROCEDURE Zeichnen;
  VAR
  P1,P2: Pt2D;
  BEGIN
  TToLine2D(Line,-200,P1);  TToLine2D(Line,200,P2);
  DrawLine2D(P1,P2,2);
  Zeichne_Kreis(Kreis,0.0,2*Pi+Eps,80);
  END;

PROCEDURE Eingabe;                (* Gerade geg: durch Punkt und Richtung *)
  BEGIN                           (* Kreis  geg: Mittelpunkt, Radius      *)  
  Line.O.X := -3.99999999; Line.O.Y :=  -2.0;         (* fester Punkt     *)
  Line.U.X :=   0.00;   Line.U.Y :=   1.00;           (* Richtunsvektor   *)
  Kreis.M.X:=   6.0;    Kreis.M.Y:=   0.0;            (* Kreismittelpunkt *)
  Kreis.R  :=  10.0;
  ScaleVt2D(Line.U,1.0,Line.U);     (* Richtungsvektor als Einheitsvektor *)
                                    (* normieren !!                       *)
  END;

{ -------------------------- main program -------------------------------- }
BEGIN
 Schnittstelle_waehlen(1);                 (* 2 bedeutet auf Datei plotten *)
  Plot := FALSE;                           (* 1 ist parallele Schnittst    *)
  einh := 0.5;   (* 1 Einheit auf der X-Achse und Y-Achse entspricht .. cm *)
  WI2D[1].X := -20.0;  WI2D[1].Y := -20.0;     (* linker unterer Punkt     *)
                                               (* des Weltfensters         *)
  Ausgangszustand_definieren;                 (* Graphikgrundeinstellung   *)
  Eingabe;
  IntersectionLineCircle(Line,Kreis,NoS,t1,t2,S1,S2);
  Zeichnen;
  Beschriftung; 
  WClosegraph;
END.